group	// custom group datum
	var
		leader	// key of the group leader
		list/members = list()	// list of group members

mob
	var
		group/Group	// the group this mob belongs to
		list/view_mobs = list()	// list of mobs loaded in the statpanels

		// several vars for simulating a game display
		hp
		maxhp
		mp
		maxmp
		list/attribute = list()

	New()
		..()
		// make random attributes for the demo
		maxhp = rand(4,20)
		hp = rand(1,maxhp)
		maxmp = rand(4,20)
		mp = rand(1,maxhp)
		suffix = "HP:[hp]/[maxhp]\nMP:[mp]/[maxmp]"
		for(var/stat in list ("Str", "Dex", "Con"))
			attribute[stat] = roll(3,6)

	Stat()
		// A unique panel name, since mobs can be loaded in other mob's panels
		statpanel(name)
		stat(src)	// icon, name, and suffix
		stat(attribute)	// display the associated list of attributes
		if(src == usr) // the rest of this is only for the mob viewing itself
			..()

			if(Group)	// if in a group
				statpanel("Group")	// make the Group panel
				for(var/mob/M in Group.members)
					if(M.key == Group.leader)	// if it's the group leader
						stat("leader",M)	// give leader a fancy red label
					else
						stat(M)	// or just show the icon, name, and suffix

				for(var/mob/M in view_mobs)	// extra mobs loaded in panels
					if(M in Group.members)	// if this mob is in my group
						M.Stat()	// have that mob show me it's stats
					else
						view_mobs -= M	// removed ungrouped mobs from my panels

	Click(location)
		// if clicked in the group panel or it's own panel
		if((location == "Group") || (location == name))
			// if already loaded in stat panels
			if(src in usr.view_mobs)
				usr.view_mobs -= src	// remove it
			else
				if(usr != src)	// if it's not the usr
					usr.view_mobs += src	// load it in the panels
				usr.client.statpanel = name	// switch to this mob's panel

	verb
		invite()
			set category = "Group"
			set src in oview()

			if(src.Group)
				usr << "<span class=group>[src] is already in a group.</span>"
				return

			if(!usr.Group)
				usr.Group = new()
				usr.Group.members += usr
				usr.Group.leader = usr.key

			usr << "<span class=group>You invite [src] to your group.</span>"
			if(!client || (alert(src, "[usr] invites you to join \his group.\n\nWould you like to join?","Join [usr]'s group?","Yes","No")=="Yes"))
				usr.Group.members << "<span class=group>[src] joins your group.</span>"
				usr.Group.members += src
				Group = usr.Group

				src << "<span class=group>You join [usr]'s group.</span>"
				if(client)
					client.statpanel = "Group"

		leave()
			set category = "Group"
			if(!Group)
				src << "<span class=group>You aren't in a group!</span>"
				return

			Group.members << "<span class=group>[src] leaves the group.</span>"

			Group.members -= src

			if(Group.members.len && (key == Group.leader))
				for(var/mob/M in Group.members)
					if(M.key)
						Group.leader = M.key
						Group.members << "<span class=group>[Group.leader] becomes the group leader.</span>"
						break

			Group = null
